#!/usr/bin/env python
# encoding: utf-8

"""
PYTHON DLA INŻYNIERÓW
Lekcja: #3 Listy

Copyright: www.oprojektowaniu.pl | 2018

Spis treści:
1. Tworzenie list
2. Indeksowanie i wycinanie list
3. Podstawowe operacje na listach
4. Listy zagnieżdżone
5. Wprowadzenie do wyrażeń listowych
6. Przykład zastosowania list
"""


# ==========================================================================
# 1. Tworzenie list
# ==========================================================================

moja_lista = [1,2,3]     # definiowanie trzyelementowej listy i przypisanie jej do zmiennej 'moja_lista'
print(moja_lista)

# Lista składająca się z kilku typów danych
x = 3
moja_lista = [1, 'dwa', 3.45, x]

# Lista może też być pusta (pusty zbiór elementów)
pusta_lista = []


# ==========================================================================
# 2. Indeksowanie i wycinanie list
# ==========================================================================

nowa_lista = [1,2,3,4,5]

# Wywołanie elementu listy za pomocą indeksu
print(moja_lista[1])   # zwróci nam wartość drugiego elementu listy, czyli tutaj liczba 2
print(moja_lista[3])   # = 4
# print(moja_lista[10])  # Indeks poza zakresem listy, Python zwróci tutaj błąd: 'IndexError: list index out of range'

# Możemy też wywołać element listy licząc ostatniego elementu
print(moja_lista[-1])  # = 5
print(moja_lista[-2])  # = 4

# Wycinanie ('slicing') wybranego ciągu elementów z listy
print(moja_lista[1:])  # Dostaniemy tutaj listę składającą się z czterech elementów [2,3,4,5]
print(moja_lista[1:3]) # Fragment listy obejmujący elementy od drugiego do trzeciego [2,3]


# ==========================================================================
# 3. Podstawowe operacje na listach
# ==========================================================================

# Łączenie list
moja_lista + ['nowy element']   # dostaniemy [1,2,3,'nowy element']
print(moja_lista)
moja_lista + [4, 5]             # = [1,2,3,4,5]
print(moja_lista)

lista2 = ['a','b','c']
moja_lista + lista2             # = [1,2,3,'a','b','c']

# Przypisanie na nowo zawartości listy
moja_lista = moja_lista + ['dodaj element na stale']

# Powielanie listy
print(moja_lista * 3)

# Zastępowanie elementu listy
moja_lista[0] = 'zastap element'
print(moja_lista)

# --------------------------------------------------------------------------
# Metody wbudowane
# --------------------------------------------------------------------------

# Dodawanie elementów do listy
moja_lista = [1,2,3]

# Długość listy (liczba elementów)
print(len(moja_lista))

# Dodawanie elementów do listy
moja_lista.append('dodaj element')          # Dodawanie elementu na koniec listy
print(moja_lista)

moja_lista.insert(1,'dodaj drugi element')  # Dodawanie elementu w miejsce o indeksie 1
print(moja_lista)

# Usuwanie elementu listy za pomocą .pop()
nowa_lista = ['a','b','c','a']
nowa_lista.pop()        # Usunięcie ostatniego elementu listy (odwrotność funkcji .append())
nowa_lista.pop(0)       # Usunięcie z listy elementu o indeksie 0
print(nowa_lista)

# Usuwanie elementu listy za pomocą .remove()
nowa_lista = ['a','b','c','a']
nowa_lista.remove('a')  			# Usunięcie z listy pierwszego wystąpienia zmiennej 'a'
print(nowa_lista)

# Przeszukiwanie list
nowa_lista = ['a','b','c','a']

print('a' in nowa_lista)           # Prawda (True) jeśli element występuje w liście, w przeciwnym przypadku fałsz (False)
print(nowa_lista.index('a'))       # Zwraca indeks pierwszego wystąpienia szukanego elementu w liście
print(nowa_lista.index('a',1,10))  # Jak wyżej tylko przeszukuje listę w zakresie indeksów od 1 do 10

print(nowa_lista.count('a'))		# Zwraca liczbę wystąpień elementu listy
print(max(nowa_lista))         		# Zwraca największy element listy
print(min(nowa_lista))         		# Najmniejszy element listy

# Modyfikowanie kolejności elementów w liście
nowa_lista = ['a','b','c','a']

# Odwracanie kolejności listy
nowa_lista.reverse()
print(nowa_lista)

# Sortowanie elementów listy
nowa_lista.sort()
print(nowa_lista)


# ==========================================================================
# 4. Listy zagnieżdżone
# ==========================================================================

# Mamy trzy listy
lista_1 = [1, 2, 3]
lista_2 = [4, 5, 6]
lista_3 = [7, 8, 9]

# Łączmy je w jedną macierz
tablica = [lista_1, lista_2, lista_3]

# Zobaczmy teraz jak wygląda nasza macierz i jak odwołujemy się do jej elementów:
print(tablica)         # Wywołanie całej macierzy
print(tablica[0])      # Wywołanie pierwszego wiersza macierzy
print(tablica[0][0])   # Wywołanie pierwszego elementu z wiersza pierwszego macierzy


# ==========================================================================
# 5. Wprowadzenie do wyrażeń listowych
# ==========================================================================

kolumna_1 = [wiersz[0] for wiersz in tablica]
print(kolumna_1)


# ==========================================================================
# 6. Przykład zastosowania list
# ==========================================================================

# Dane
belka1 = [0.2, 0.5]     # Wymiary przekroju belki w [m], lista zawiera odpowiednio szerokość (b) i wysokość (h) przekroju
belka2 = [0.3, 0.6]     # Jak wyżej
belka3 = [0.4, 0.4]     # Jak wyżej
F = [200, 300, 400]     # Siły podłużne w [kN] odpowiednio w kolejnych belkach (1,2,3)

# Obliczenia
belki = [belka1, belka2, belka3]    # zbiór belek jako macierz
pole = []                           # lista pól przekroju poszczególnych belek (tutaj pusta)
sigma = []                          # lista naprężeń normalnych belek (tutaj pusta)

for i in range(len(belki)):
    pole.append(belki[i][0] * belki[i][1])
    sigma.append(F[i] / pole[i] / 1000)

# Wydruk wyników
print('Naprężenia normalne w belkach:')
print(" - Pole przekroju belki 'i':         ", pole, 'm2')
print(" - Naprężenie normalne w belce 'i':  ", sigma, 'MPa')